#include <Arduino.h>
#include <DS1307RTC.h>
#include <LiquidCrystal_I2C.h>

#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978
#define REST      0

// change this to make the song slower or faster
int tempo = 140;

// change this to whichever pin you want to use

// notes of the moledy followed by the duration.
// a 4 means a quarter note, 8 an eighteenth , 16 sixteenth, so on
// !!negative numbers are used to represent dotted notes,
// so -4 means a dotted quarter note, that is, a quarter plus an eighteenth!!
int melody[] = {

  // Take on me, by A-ha
  // Score available at https://musescore.com/user/27103612/scores/4834399
  // Arranged by Edward Truong

  NOTE_FS5,8, NOTE_FS5,8,NOTE_D5,8, NOTE_B4,8, REST,8, NOTE_B4,8, REST,8, NOTE_E5,8, 
  REST,8, NOTE_E5,8, REST,8, NOTE_E5,8, NOTE_GS5,8, NOTE_GS5,8, NOTE_A5,8, NOTE_B5,8,
  NOTE_A5,8, NOTE_A5,8, NOTE_A5,8, NOTE_E5,8, REST,8, NOTE_D5,8, REST,8, NOTE_FS5,8, 
  REST,8, NOTE_FS5,8, REST,8, NOTE_FS5,8, NOTE_E5,8, NOTE_E5,8, NOTE_FS5,8, NOTE_E5,8,
  NOTE_FS5,8, NOTE_FS5,8,NOTE_D5,8, NOTE_B4,8, REST,8, NOTE_B4,8, REST,8, NOTE_E5,8, 
  
  REST,8, NOTE_E5,8, REST,8, NOTE_E5,8, NOTE_GS5,8, NOTE_GS5,8, NOTE_A5,8, NOTE_B5,8,
  NOTE_A5,8, NOTE_A5,8, NOTE_A5,8, NOTE_E5,8, REST,8, NOTE_D5,8, REST,8, NOTE_FS5,8, 
  REST,8, NOTE_FS5,8, REST,8, NOTE_FS5,8, NOTE_E5,8, NOTE_E5,8, NOTE_FS5,8, NOTE_E5,8,
  NOTE_FS5,8, NOTE_FS5,8,NOTE_D5,8, NOTE_B4,8, REST,8, NOTE_B4,8, REST,8, NOTE_E5,8, 
  REST,8, NOTE_E5,8, REST,8, NOTE_E5,8, NOTE_GS5,8, NOTE_GS5,8, NOTE_A5,8, NOTE_B5,8,
  
  NOTE_A5,8, NOTE_A5,8, NOTE_A5,8, NOTE_E5,8, REST,8, NOTE_D5,8, REST,8, NOTE_FS5,8, 
  REST,8, NOTE_FS5,8, REST,8, NOTE_FS5,8, NOTE_E5,8, NOTE_E5,8, NOTE_FS5,8, NOTE_E5,8,
  
};

// sizeof gives the number of bytes, each int value is composed of two bytes (16 bits)
// there are two values per note (pitch and duration), so for each note there are four bytes
int notes = sizeof(melody) / sizeof(melody[0]) / 2;

// this calculates the duration of a whole note in ms
int wholenote = (60000 * 4) / tempo;

int divider = 0, noteDuration = 0;

#define SET_BUTTON PD2
#define PLUS_BUTTON PD3
#define MINUS_BUTTON PD4
#define RESET_BUTTON PD5
#define buzzer 6
#define MOTOR1IN1 7
#define MOTOR1IN2 8
#define MOTOR2IN1 11
#define MOTOR2IN2 12
#define PWM_MOTOR1 9
#define PWM_MOTOR2 10

int mode = 0;
int alarm_hour = 0;
int alarm_minutes = 0;
int alarm_is_set = 0;
LiquidCrystal_I2C lcd(0x27, 16, 2);
tmElements_t tm;
const char *monthName[12] = {
  "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

void setup() {
  DDRD &= ~(1 << SET_BUTTON);
  PORTD |= (1 << SET_BUTTON);

  DDRD &= ~(1 << PLUS_BUTTON);
  PORTD |= (1 << PLUS_BUTTON);

  DDRD &= ~(1 << MINUS_BUTTON);
  PORTD |= (1 << MINUS_BUTTON);

  DDRD &= ~(1 << RESET_BUTTON);
  PORTD |= (1 << RESET_BUTTON);

  pinMode(MOTOR1IN1, OUTPUT);
  pinMode(MOTOR1IN2, OUTPUT);
  pinMode(MOTOR2IN1, OUTPUT);
  pinMode(MOTOR2IN2, OUTPUT);
  pinMode(PWM_MOTOR1, OUTPUT);
  pinMode(PWM_MOTOR2, OUTPUT);
  digitalWrite(MOTOR1IN1, HIGH);
  digitalWrite(MOTOR1IN2, LOW);
  digitalWrite(MOTOR2IN1, LOW);
  digitalWrite(MOTOR2IN2, HIGH);

  digitalWrite(buzzer, 0);

  lcd.init();
  lcd.backlight();
  lcd.clear();
  Serial.begin(9600);

  initRTC();
  alarm_hour = tm.Hour;
  alarm_minutes = tm.Minute;

  showTime();
}

void initRTC() {
  if (!RTC.read(tm)) {
    if (RTC.chipPresent()) {
      bool parse=false;
      bool config=false;
      if (getDate(__DATE__) && getTime(__TIME__)) {
        parse = true;
        if (RTC.write(tm)) {
          config = true;
        }
      }
    }
  }
}

bool getTime(const char *str)
{
  int Hour, Min, Sec;

  if (sscanf(str, "%d:%d:%d", &Hour, &Min, &Sec) != 3) return false;
  tm.Hour = Hour;
  tm.Minute = Min;
  tm.Second = Sec;
  return true;
}

bool getDate(const char *str)
{
  char Month[12];
  int Day, Year;
  uint8_t monthIndex;

  if (sscanf(str, "%s %d %d", Month, &Day, &Year) != 3) return false;
  for (monthIndex = 0; monthIndex < 12; monthIndex++) {
    if (strcmp(Month, monthName[monthIndex]) == 0) break;
  }
  if (monthIndex >= 12) return false;
  tm.Day = Day;
  tm.Month = monthIndex + 1;
  tm.Year = CalendarYrToTm(Year);
  return true;
}

void print2digits(int number) {
  if (number >= 0 && number < 10) {
    lcd.print("0");
  }
  lcd.print(number);
}

void showHour() {
  lcd.setCursor(6,1);
  print2digits(tm.Hour);
  lcd.print(":");
  print2digits(tm.Minute);
}

void showTime() {
  RTC.read(tm);
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("Hello, it is");
  lcd.setCursor(0,1);
  print2digits(tm.Hour);
  lcd.print(":");
  print2digits(tm.Minute);
  lcd.print(" ");
  print2digits(tm.Day);
  lcd.print("/");
  print2digits(tm.Month);
  lcd.print("/");
  print2digits(tmYearToCalendar(tm.Year));
}

void change_alarm() {
    Serial.println("Change alarm mode");
    while(1) {
      if ((PIND & (1<<SET_BUTTON)) == 0) {
        mode++;
      }
      if (mode == 5) {
        alarm_is_set = 1;
        mode = 0;
        break;
      }
      
      if (mode == 3) {
        lcd.clear();
        lcd.setCursor(1,0);
        lcd.print("Set alarm hour");
        displayAlarm();
      }
      if (mode == 4) {
        lcd.clear();
        lcd.setCursor(0,0);
        lcd.print("Set alarm minutes");
        displayAlarm();
      }
      
      if ((PIND & (1<<PLUS_BUTTON)) == 0) {
        if (mode == 3) {
          alarm_hour = (alarm_hour + 1) % 24;
        } else if (mode == 4) {
          alarm_minutes = (alarm_minutes + 1) % 60;
        }
      }
      if ((PIND & (1<<MINUS_BUTTON)) == 0) {
        if (mode == 3) {
          if (alarm_hour > 0)
            alarm_hour--;
          else if (alarm_hour == 0)
            alarm_hour = 23;
        } else if (mode == 4) {
          if (alarm_minutes > 0)
            alarm_minutes--;
          else if (alarm_minutes == 0)
            alarm_minutes = 59;
        }
      delay(600);
    }
    delay(600);
  }
}

void displayAlarm() {
  lcd.setCursor(5,1);
  if (alarm_hour < 10)
    lcd.print("0");
  lcd.print(String(alarm_hour));
  lcd.print(":");
  if (alarm_minutes < 10)
    lcd.print("0");
  lcd.print(String(alarm_minutes));
}

void change_hour() {
  while(1) {
    if ((PIND & (1<<SET_BUTTON)) == 0) {
      mode++;
    }
    if (mode == 3) {
      break;
    }
    
    if (mode == 1) {
      lcd.clear();
      lcd.setCursor(1,0);
      lcd.print("Set clock hour");
      showHour();
    }
    if (mode == 2) {
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("Set clock minutes");
      showHour();
    }

    if ((PIND & (1<<PLUS_BUTTON)) == 0) {
      if (mode == 1) {
        tm.Hour = (tm.Hour + 1) % 24;
      } else if (mode == 2) {
        tm.Minute = (tm.Minute + 1) % 60;
      }
      RTC.write(tm);
    }

    if ((PIND & (1<<MINUS_BUTTON)) == 0) {
      if (mode == 1) {
        if (tm.Hour == 0)
          tm.Hour = 23;
        else
          tm.Hour -= 1;
      } else if (mode == 2) {
        if (tm.Minute == 0)
          tm.Minute = 59;
        else
          tm.Minute -= 1;
      }
      RTC.write(tm);
    }
    
    delay(600);
  }
  delay(600);
  change_alarm();
}

void showResetMessage() {
  lcd.clear();
  lcd.setCursor(3,0);
  lcd.print("Alarm reset");
  delay(600);
}

void loop() {
  // put your main code here, to run repeatedly:
  if ((PIND & (1<<SET_BUTTON)) == 0) {
    mode++;
    if (mode == 1) {
      delay(600);
      change_hour();
    }
  }

  if ((PIND & (1<<RESET_BUTTON)) == 0) {
    alarm_is_set = 0;
    alarm_hour = tm.Hour;
    alarm_minutes = tm.Minute;
    showResetMessage();
    delay(600);
  }
  showTime();
  if ((alarm_is_set == 1) && (tm.Hour == alarm_hour) && (tm.Minute == alarm_minutes)) {
    int go = 1;
    digitalWrite(buzzer, 1);
    digitalWrite(PWM_MOTOR1, 1);
    digitalWrite(PWM_MOTOR2, 1);
    while (go) {
      // iterate over the notes of the melody.
      // Remember, the array is twice the number of notes (notes + durations)
      for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {
        if (thisNote % 8 == 0)
          showTime();
        // calculates the duration of each note
        divider = melody[thisNote + 1];
        if (divider > 0) {
          // regular note, just proceed
          noteDuration = (wholenote) / divider;
        } else if (divider < 0) {
          // dotted notes are represented with negative durations!!
          noteDuration = (wholenote) / abs(divider);
          noteDuration *= 1.5; // increases the duration in half for dotted notes
        }
    
        // we only play the note for 90% of the duration, leaving 10% as a pause
        tone(buzzer, melody[thisNote], noteDuration * 0.9);
    
        // Wait for the specief duration before playing the next note.
        delay(noteDuration);
    
        // stop the waveform generation before the next note.
        noTone(buzzer);

        if ((PIND & (1<<RESET_BUTTON)) == 0) {
          alarm_is_set = 0;
          alarm_hour = tm.Hour;
          alarm_minutes = tm.Minute;
          showResetMessage();
          go = 0;
          delay(600);
          break;
        }
      }
    }
    digitalWrite(buzzer, 0);
    digitalWrite(PWM_MOTOR1, 0);
    digitalWrite(PWM_MOTOR2, 0);
  }
  delay(600);
}
